require "crocker/version"
require 'uri'
require 'net/http'
require 'digest'
require 'json'

module Crocker
  class Validator
    def self.validate(params)
      return unless id_and_password_present?(params)
      uri       = URI.parse(params.delete(:api_url)||API_URL) rescue ''
      signature = Digest::MD5.hexdigest([params.delete(:user_password), params.delete(:secret)||API_SECRET].join) rescue ''
      uri.query = URI.encode_www_form({
                                        :userid    => params.delete(:user_id),
                                        :signature => signature
                                      }) rescue nil
      response = JSON.parse(Net::HTTP.get_response(uri).body.downcase) rescue {}
      response['success'] == true ? response['token'].downcase : nil      
    end

    def self.id_and_password_present?(params)
      params[:user_id] && params[:user_password]
    end
  end
end
